#ifndef _SERIALBW_H
#define _SERIALBW_H

#include <unistd.h>

#define SBW_SERVEROK 1
#define SBW_LINEUP   2

typedef struct serialbwcomms
{
	volatile int sbw_flags;		/* Server/line status */
	volatile unsigned long rx_count;
	volatile unsigned long tx_count;
	volatile unsigned long txrx_count;
	volatile pid_t rx_req;
	volatile pid_t rx_ack;
	volatile pid_t tx_req;
	volatile pid_t tx_ack;
	volatile pid_t rx_go;
	volatile pid_t tx_go;
	volatile double new_rate;	/* Chars per sec below which can start another process */
	volatile double new_tgap;	/* Min interval between starting processes */
} SERIALBW, *SERIALBW_PTR;

#define SEGSIZE sizeof(SERIALBW)

/* Protocol:
 * client waits for rx_req == 0
 * then it puts its process id in rx_req
 * and checks when rx_ack goes non-zero the number is what it wrote in rx_req
 * if so, clear rx_req and go to sleep, waiting for SIGCONT
 * 
 * When bandwidth available server gets next pid from the queue and places in rx_go
 * then sends SIGCONT to the process
 *
 * Same for tx side
 *
 * When line drops, everything reinitialised
 *
 * _count variables are updated at high speed to allow easy tracking
 */

#endif
