#include <stdlib.h>
#include <sys/ioctl.h>
#include <stdio.h>
#include <fcntl.h>
#include <errno.h>
#include "serialmon-ioctl.h"

int
main(int argc, char *argv[])
{
	int fd;
	int rubbish;
	struct serial_stats_struct info;
	char *devname;
	if(argc >= 2)
	{
		fd = open(argv[1], O_NONBLOCK | O_RDONLY);
		if(fd < 0)
		{
			fprintf(stderr, "Failed to open device %s - ", argv[1]);
			perror("");
			exit(1);
		}
		devname = argv[1];
		/* Check the normal ioctl */
		if(ioctl(fd, TIOCSERGSTATS, &info) < 0)
		{
			perror("TIOCSERGSTATS ioctl failed (module not loaded ?) - ");
			exit(errno);
		}
		/* Release the module */
		if(ioctl(fd, TIOCSERRELMOD, &rubbish) < 0)
		{
			if(errno == EINVAL)
			{
				fprintf(stderr, "Module not loaded, or already released for %s\n", devname);
				exit(0);
			}
			perror("Module could not be released - ");
			exit(errno);
		}
	}
	return 0;
}
