#ifndef _SHMEMSERV_H
#define _SHMEMSERV_H

#include <sys/time.h>
#include "serialbw.h"

#define	SHMEM_INIT_OK  0
#define	SHMEM_FAILED_KEY 1
#define	SHMEM_FAILED_GET 2
#define	SHMEM_FAILED_MAP 3

extern double rate_threshold;	/* Chars per sec below which can start another process */
extern double min_interval;		/* Min interval between starting processes */

extern int shmemserv_init(char *line, SERIALBW_PTR *sbwptr);
extern void shmemserv_lineup(SERIALBW_PTR ptr, struct timeval *now);
extern void shmemserv_linedown(SERIALBW_PTR ptr, struct timeval *now);
extern void shmemserv_shutdown(SERIALBW_PTR ptr, struct timeval *now);
extern void shmemserv_scan(SERIALBW_PTR ptr, struct timeval *now);

#endif
